/* 
    Ec     Copyright (C)   2001 Marc Dechico

    ec_ech_g.c : create includes files that are used to
		 create constant table.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 80 83 74 99
				Mail: Marc.DECHICO@wanadoo.fr
    
*/


/***************************************************************
 Gnre plusieurs fichiers include pour charger les table
 de controle si echec							
****************************************************************/
#include	<config.h>
#include	<stdio.h>
#include	"ec_defin.i"
/* Increment selon direction dplacement */
int ti_inc_dir[19];
/* calcul direction echec pour le cavalier */
int ti_cal_dir_cav[43];

int ti_ech_dir_rei[100][100]; 
int ti_ech_dir_tou[100][100]; 
int ti_ech_dir_fou[100][100]; 
int ti_ech_dir_cav[100][100]; 
int ti_ech_dir_roi[100][100]; 
int ti_ech_dir_pio_noi[100][100]; 
int ti_ech_dir_pio_bla[100][100]; 
int ti_ech_dir_inc[100][100];

void ini(void);
void ini_ech_par(void);
void ini_ech_par_null (int no, int nr);
void ini_ech_par_tfr (int no,int nr);
void ini_ech_par_cav  (int no,int nr);
void ini_ech_par_roi      (int no,int); 
void ini_ech_par_pio_noi  (int no,int nr);
void ini_ech_par_pio_bla  (int no,int nr);
int ctl_if_nul(int no,int nr);
int cre_inc_fil(char *filename,int pti_table[100][100] );
int main (void)
{
  ini_ech_par();
  cre_inc_fil("ec_echre.i",ti_ech_dir_rei);
  cre_inc_fil("ec_echto.i",ti_ech_dir_tou);
  cre_inc_fil("ec_echfo.i",ti_ech_dir_fou);
  cre_inc_fil("ec_echca.i",ti_ech_dir_cav);
  cre_inc_fil("ec_echro.i",ti_ech_dir_roi);
  cre_inc_fil("ec_echpn.i",ti_ech_dir_pio_noi);
  cre_inc_fil("ec_echpb.i",ti_ech_dir_pio_bla);
  cre_inc_fil("ec_echin.i",ti_ech_dir_inc);
}
void ini(void)
{
  int x;
  ti_inc_dir[0]=0;
  ti_inc_dir[1]=11;
  ti_inc_dir[2]=9;
  ti_inc_dir[3]=-9;
  ti_inc_dir[4]=-11;
  ti_inc_dir[5]=10;
  ti_inc_dir[6]=-10;
  ti_inc_dir[7]=1;
  ti_inc_dir[8]=-1;
  /* bug :  completer ? */

  /* calcul direction echec par cavalier */
	for (x=0;x<=42;x++)  ti_cal_dir_cav[x]=0;
	ti_cal_dir_cav[0] = 9;
	ti_cal_dir_cav[9] = 10;
	ti_cal_dir_cav[29]= 11;
	ti_cal_dir_cav[40]= 12;
	ti_cal_dir_cav[42]= 13;
	ti_cal_dir_cav[33]= 14;
	ti_cal_dir_cav[13]= 15;
	ti_cal_dir_cav[2] = 16;


}
int ctl_if_nul(int no,int nr)
{
  int wn,wn0,wn9;
  if (no==nr) return 1;
  wn= no/10;
  wn0=wn*10;
  wn9=wn+9;
  if (no==wn0 ||no==wn9)return 1;
  wn= nr/10;
  wn0=wn*10;
  wn9=wn+9;
  if (nr==wn0 ||nr==wn9)return 1;
  return 0;
}
void ini_ech_par(void)
{
  int nr,no;
  ini();
  for(no=0;no<100;no++)
    {
      for(nr=0;nr<100;nr++)
	{
	  if(ctl_if_nul(no,nr))

		    {
	      ini_ech_par_null(no,nr);
	    }
	  else
	    {
	      ini_ech_par_null(no,nr);
	      ini_ech_par_tfr(no,nr);
	      ini_ech_par_cav(no,nr);
	      ini_ech_par_roi(no,nr);
	      ini_ech_par_pio_noi(no,nr);
	      ini_ech_par_pio_bla(no,nr);
	
	    }
	}
    }
}


void ini_ech_par_null (int no, int nr)
{
 
 ti_ech_dir_rei[no][nr]		= 0;
 ti_ech_dir_tou[no][nr]     	= 0;
 ti_ech_dir_fou[no][nr]    	= 0;
 ti_ech_dir_cav[no][nr]     	= 0;
 ti_ech_dir_pio_noi[no][nr] 	= 0;
 ti_ech_dir_pio_bla[no][nr] 	= 0;

}
void ini_ech_par_tfr (int no,int nr)
{
  /* initialisation pour ctl echec par reine tour et fou */
  int xo,yo;
  int xr,yr;
  int dx,dy;

  yo=no /10;
  xo=no-yo*10;

  yr=nr /10;
  xr=nr-yr*10;
  
  dx=xr-xo;
  dy=yr-yo;

  if ( dx == 0)               /* roi et case sur mme colonne */
    {

      if (dy < 0)          /* case en dessus */
	{
	 ti_ech_dir_rei[no][nr] = 5;		 				/* cas_ctl_h      */
	 ti_ech_dir_tou[no][nr] = 5;		 				
	 ti_ech_dir_inc[no][nr] = ti_inc_dir[5];
	
	}
      else                 /* case en dessous */
	{
	 ti_ech_dir_rei[no][nr] = 6;		 				/* cas_ctl_b      */
	 ti_ech_dir_tou[no][nr] = 6;		 				
	 ti_ech_dir_inc[no][nr] = ti_inc_dir[6];
	}
    }
  else
    {
		if (dy == 0) 		/* roi et case sur mme ligne */
	{
	  if (dx<0)            /* case  droite */
	    {
	     ti_ech_dir_rei[no][nr] = 7;			               /* cas_ctl_d      */
	     ti_ech_dir_tou[no][nr] = 7;	
	     ti_ech_dir_inc[no][nr] = ti_inc_dir[7];
	    }
	  else                 /* case  gauche  */
	    {
	     ti_ech_dir_rei[no][nr] = 8;	  	 	               /* cas_ctl_g      */
	     ti_ech_dir_tou[no][nr] = 8;		 		    
	     ti_ech_dir_inc[no][nr] = ti_inc_dir[8];
	    }

	}
      else
	{
	  if (dx == dy) 		/* diagonal montante de gauche  droite */
		 {
	      if (dy > 0)            /* case  gauche */
		{
		 ti_ech_dir_rei[no][nr] = 4;		 	/* cas_ctl_b_g      */
		 ti_ech_dir_fou[no][nr] = 4;		
		 ti_ech_dir_inc[no][nr] = ti_inc_dir[4];
		}
	      else                /* case  droite */
		{
		 ti_ech_dir_rei[no][nr] = 1;		 	/* cas_ctl_h_d      */
		 ti_ech_dir_fou[no][nr] = 1;
		 ti_ech_dir_inc[no][nr] = ti_inc_dir[1];
		}

	    }
	  else
	    {
	      if (dx == -dy)     	/* diagonal descendante de gauche  droite*/
		{
		  if (dy < 0)            /* case  gauche */
		    {
		     ti_ech_dir_rei[no][nr] = 2;		 /* cas_ctl_h_g      */
		     ti_ech_dir_fou[no][nr] = 2;	
		     ti_ech_dir_inc[no][nr] = ti_inc_dir[2];
		    }
		  else                /* case  droite */
		    {
		     ti_ech_dir_rei[no][nr] = 3;		  /* cas_ctl_h      */
		     ti_ech_dir_fou[no][nr] = 3;	
		     ti_ech_dir_inc[no][nr] = ti_inc_dir[3];		
		    }
		}
	    }
	}
    }
}


void ini_ech_par_cav      (int no,int nr)
{  
  int dn;                                  /* difference pos_n 	*/
  dn = nr-no ;
	
  if ((abs(dn))<=21)
    {
     ti_ech_dir_cav[no][nr] = ti_cal_dir_cav[dn+21];
    }
  else
    {
      ti_ech_dir_cav[no][nr] = 0;
    } 

}
void ini_ech_par_roi      (int no,int nr)
{  
  int dn;                                  /* difference pos_n 	*/

  dn = nr-no ;
  switch(dn)
    {
    case  -10 :                           /* case en haut  */                         
      ti_ech_dir_roi[no][nr] = 1;
      break;
    case  -11 :                           /* case haut droite */                         
      ti_ech_dir_roi[no][nr] = 1;
      break;
    case  -1  :                            /* case  droite */                         
      ti_ech_dir_roi[no][nr] = 1;
      break;
    case  +9  :                           /* case bas droite */                         
      ti_ech_dir_roi[no][nr] = 1;
      break;
    case  +10 :                           /* case en bas  */                         
      ti_ech_dir_roi[no][nr] = 1;
      break;
    case  +11 :                           /* case bas gauche */                         
      ti_ech_dir_roi[no][nr] = 1;
      break;
    case  +1  :                           /* case  gauche */                         
      ti_ech_dir_roi[no][nr] = 1;
      break;
    case  -9  :                           /* case haut gauche */                         
      ti_ech_dir_roi[no][nr] = 1;
      break;
    default:
      ti_ech_dir_roi[no][nr] = 0;
      break;
    }
	
 
}
void ini_ech_par_pio_noi  (int no,int nr)
{
  int dn;                                  /* difference pos_n 	*/

  dn = nr-no;
	
  switch(dn)
    {
    case  -9 :                          /* pion  gauche */
      ti_ech_dir_pio_noi[no][nr] = 18;
      break;
    case -11 :                          /* pion  droite */
      ti_ech_dir_pio_noi[no][nr] = 17;
      break;
    default:
      ti_ech_dir_pio_noi[no][nr] = 0;
      break;
    }
}
void ini_ech_par_pio_bla  (int no,int nr)
{
  int dn;                                  /* difference pos_n 	*/

  dn = nr- no;
 	
  switch(dn)
    {
    case 11 :                          /* pion  gauche */
     ti_ech_dir_pio_bla[no][nr] = 18; 
      break;
    case 9  :                          /* pion  droite */
     ti_ech_dir_pio_bla[no][nr] = 17;
      break;
    default:
     ti_ech_dir_pio_bla[no][nr]  = 0;
      break;
    }

}
int cre_inc_fil(char *filename,int ti_table[100][100] )
{
  FILE *pf_fil;
   int no,nr;
  if ( (pf_fil= fopen(filename,"w")) !=NULL )
    { 
     
      for(no=0;no<100;no++)
	{
	  if (no != 0)
	    fprintf(pf_fil,",{");
	  else
	    fprintf(pf_fil," {");

	  for(nr=0;nr<100;nr++)
	    {
	      if (nr != 0)fprintf(pf_fil,",");
	      fprintf(pf_fil,"%i",ti_table[no][nr]);
	    }
	  fprintf(pf_fil,"}\n");
      
	}

      
      return 0;	
    }
  else
    {
      /*Erreur d'ecriture */
      printf("\nErreur d'criture ");
      return -1;
    }

  fclose (pf_fil);

}

